/* etunnel 0.0.5
 * Copyright (C) 2003-2004 Kostas Petrikas
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "etunnel.h"

#define leng strlen(config.p_user)+strlen(config.p_pass)+1

int http_connect(int sck, int rport, char rhost[]){
	char command[]   = "CONNECT ",
	     http10[]    = "HTTP/1.0\r\n",
	     http_auth[] = "Proxy-Authorization: Basic ",
	     *base64buff,
	     *base64,
	     ch;
	
	int i,rd;
	     
	char buff[2048];
	
	bzero((char *)&buff,sizeof(buff));
	if((config.p_user == NULL) && (config.p_pass == NULL)){
		snprintf(buff,sizeof(buff),"%s%s:%d %s\r\n",command,
		rhost,rport,http10);
	}
	else{
		base64buff = (void *)malloc(leng);
		base64     = (void *)malloc(512);
		sprintf(base64buff,"%s:%s",config.p_user,config.p_pass);
		__b64_ntop(base64buff,leng,base64,512);
		snprintf(buff,sizeof(buff),"%s%s:%d %s%s%s\r\n\r\n",command,
		rhost,rport,http10,http_auth,base64);
	}
	if( send(sck,buff,strlen(buff),0) < 1 ){
		return -1;
	}
	bzero((char *)&buff,sizeof(buff));

	rd = read(sck, buff, 12);
	if(rd <= 0) {
		return 0;
	}

	buff[rd] = '\0';

	if( atoi(buff+9) != 0xc8 ) {
		i = ch = 0;
		bzero((char *)&buff,sizeof(buff));
		while((ch != '\r')){
			ch = read_byte(sck);
			if(ch != '\r')buff[i] = ch;
			if( ++i == sizeof(buff) )break;
		}
		elog(&config,"HTTP -> %s\n", buff);
		return 0;
	}

	for(i = 0; i < 4; i++) {
		buff[i] = read_byte(sck);
		if(buff[i] == -1) {
			return 0;
		}
	}
	while(strncmp(buff, "\r\n\r\n", 4) != 0) {
		for(i = 0; i < 3; i++)
			buff[i] = buff[i+1];
		buff[3] = read_byte(sck);
		if(buff[3] == -1) {
			return 0;
		}
	}
	
	elog(&config,"HTTP -> Connected!\n");

	return 1;
}
